*****************************************************************
* Name: TGLINK.PRG                                              *
* Ver: 1.0            						*
* Desc: Bridge to tGRAPH                                        *
* Author: Todd W. Lindley                                       *
* Date: 12/19/91                                                *
*****************************************************************
* HOC                                                           *
* DATE      DESC                                                *
* --------  ----------------------------------------------------*
* 07/11/94  PRINT BLANK LINE BEFORE CREATING .TGR FILE          *
*****************************************************************

** housekeeping **
SET ESCAPE OFF
SET TALK OFF
SET SCORE OFF
SET STAT OFF
SET HEAD OFF
SET COLOR OF NORMAL TO W+/B
SET COLOR OF FIELDS TO GR+/R
SET COLOR OF BOX TO W+/N
SET COLOR OF TITLES TO N/W
SET COLOR OF HIGHLIGHT TO N/W
SET COLOR OF MESSAGES TO W+/N
SET CONFIRM ON
SET BORDER TO DOUBLE
ON KEY LABEL F10 DO draw_graph
CLOSE ALL
CLEAR
IF FILE("tgdata.dbf") 
  USE tgdata ORDER names IN 2
ELSE
  ?? CHR(7)
  @1,1 SAY "tGLINK requires TGDATA.DBF.  Refer to tGLINK.DOC"
  RETURN
ENDIF


*******************************************************************
* initialize variables first thing, instead of declaring PUBLIC   *
*******************************************************************
max_colors=13
max_sets=5
DECLARE data[max_sets],field[max_sets],clrs[max_colors],titles[max_sets+3]
DECLARE pattern[max_sets],clr_num[max_colors],patt_num[max_sets]

  field[1]=SPACE(10)
  field[2]=SPACE(10)
  field[3]=SPACE(10)
  field[4]=SPACE(10)
  field[5]=SPACE(10)

  titles[1]=SPACE(30)
  titles[2]=SPACE(30)
  titles[3]=SPACE(30)
  titles[4]=SPACE(30)
  titles[5]=SPACE(15)
  titles[6]=SPACE(15)
  titles[7]=SPACE(15)  
  titles[8]=SPACE(15)
  x=1
  DO WHILE x <= max_sets  
    data[x]=''
    field[x]=''
    pattern[x]='Solid'
    patt_num[x]=1
    x=x+1    
  ENDDO
    x=1

  DO WHILE x<=max_colors
    clr_num[x]=15
    clrs[x]='White'
    x=x+1
  ENDDO
    clrs[13]='Black'
    clr_num[13]=0

  ptr=1
  prmt=''
  bar=CHR(251)
  graphtype='BAR'
  line='' 
  pie=''
  fname=SPACE(20)
  grname=SPACE(15)
  grid=.F.

** Define menus and popups **
DEFINE MENU main
DEFINE PAD file OF main PROMPT "File" AT 0,1
DEFINE PAD data OF main PROMPT "Data" AT 0,8
DEFINE PAD graph OF main PROMPT "Type" AT 0,16
DEFINE PAD titles OF main PROMPT "Titles" AT 0,24
DEFINE PAD colors OF main PROMPT "Colors" AT 0,34
DEFINE PAD patts OF main PROMPT "Patterns" AT 0,44
DEFINE PAD grid OF main PROMPT "Grid" AT 0,56
DEFINE PAD exit OF main PROMPT "Quit" AT 0,64

DEFINE POPUP file_pop FROM 1,1
DEFINE BAR 1 OF file_pop PROMPT "  Load {}"
DEFINE BAR 2 OF file_pop PROMPT "  Save"
DEFINE BAR 3 OF file_pop PROMPT "  Create .TGR file  "
DEFINE BAR 4 OF file_pop PROMPT "  New"
ON SELECTION POPUP file_pop DO files_menu

DEFINE POPUP data_pop FROM 1,8
DO def_data
ON SELECTION POPUP data_pop DO get_dbf

DEFINE POPUP graph_pop FROM 1,16
DO def_graphs
ON SELECTION POPUP graph_pop DO get_graph

DEFINE POPUP titles_pop FROM 1,24
DO def_titles
ON SELECTION POPUP titles_pop DO get_titles

DEFINE POPUP colors_pop FROM 1,34
DO def_colors
ON SELECTION POPUP colors_pop DO get_color

DEFINE POPUP patts_pop FROM 1,44
DO def_patts
ON SELECTION POPUP patts_pop DO get_patts

DEFINE POPUP exit_pop FROM 1,64
DEFINE BAR 1 OF exit_pop PROMPT "  Quit  "
ON SELECTION POPUP exit_pop DO exit_prog

DEFINE POPUP grid_pop FROM 1,56
DEFINE BAR 1 OF grid_pop PROMPT "  Off  "
ON SELECTION POPUP grid_pop DO get_grid


DEFINE POPUP patt_list FROM 5,61
DEFINE BAR 1 OF patt_list PROMPT "  Empty"
DEFINE BAR 2 OF patt_list PROMPT "  Solid"
DEFINE BAR 3 OF patt_list PROMPT "  Lines"
DEFINE BAR 4 OF patt_list PROMPT "  Slashes - Thin"
DEFINE BAR 5 OF patt_list PROMPT "  Slashes - Thick"
DEFINE BAR 6 OF patt_list PROMPT "  Back Slashes - Thin" 
DEFINE BAR 7 OF patt_list PROMPT "  Back Slashes - Thick  "
DEFINE BAR 8 OF patt_list PROMPT "  Cross Hatch - Light"
DEFINE BAR 9 OF patt_list PROMPT "  Cross Hatch - Heavy"
DEFINE BAR 10 OF patt_list PROMPT "  Interleave"
DEFINE BAR 11 OF patt_list PROMPT "  Dots - Wide"
DEFINE BAR 12 OF patt_list PROMPT "  Dots - Close"
DEFINE BAR 13 OF patt_list PROMPT "  Reset"
ON SELECTION POPUP patt_list DEACTIVATE POPUP

DEFINE POPUP color_list FROM 3,56
DEFINE BAR 1 OF color_list PROMPT "  Black"
DEFINE BAR 2 OF color_list PROMPT "  Blue"
DEFINE BAR 3 OF color_list PROMPT "  Green"
DEFINE BAR 4 OF color_list PROMPT "  Cyan"
DEFINE BAR 5 OF color_list PROMPT "  Red"
DEFINE BAR 6 OF color_list PROMPT "  Magenta"
DEFINE BAR 7 OF color_list PROMPT "  Brown"
DEFINE BAR 8 OF color_list PROMPT "  Light Gray"
DEFINE BAR 9 OF color_list PROMPT "  Dark Gray"
DEFINE BAR 10 OF color_list PROMPT "  Light Blue"
DEFINE BAR 11 OF color_list PROMPT "  Light Green"
DEFINE BAR 12 OF color_list PROMPT "  Light Cyan"
DEFINE BAR 13 OF color_list PROMPT "  Light Red"
DEFINE BAR 14 OF color_list PROMPT "  Light Magenta  "
DEFINE BAR 15 OF color_list PROMPT "  Yellow"
DEFINE BAR 16 OF color_list PROMPT "  White"
DEFINE BAR 17 OF color_list PROMPT "  Reset"
ON SELECTION POPUP color_list DEACTIVATE POPUP

DEFINE POPUP er_data FROM 9,8
DEFINE BAR 1 OF er_data PROMPT " Set 1  "
DEFINE BAR 2 OF er_data PROMPT " Set 2  "
DEFINE BAR 3 OF er_data PROMPT " Set 3  "
DEFINE BAR 4 OF er_data PROMPT " Set 4  "
DEFINE BAR 5 OF er_data PROMPT " Labels  "
ON SELECTION POPUP er_data DEACTIVATE POPUP

ON PAD file OF main ACTIVATE POPUP file_pop
ON PAD data OF main ACTIVATE POPUP data_pop
ON PAD graph OF main ACTIVATE POPUP graph_pop
ON PAD titles OF main ACTIVATE POPUP titles_pop
ON PAD colors OF main ACTIVATE POPUP colors_pop
ON PAD patts OF main ACTIVATE POPUP patts_pop
ON PAD grid OF main ACTIVATE POPUP grid_pop
ON PAD exit OF main ACTIVATE POPUP exit_pop


SELE 2
DEFINE POPUP graph_list FROM 7,1 PROMPT FIELD name
ON SELECTION POPUP graph_list DEACTIVATE POPUP
SELE 1

** to view other files, change the LIKE *.DBF to another wild card ** 
DEFINE POPUP dbf_list FROM 9,8 PROMPT FILES LIKE *.DBF
ON SELECTION POPUP dbf_list DEACTIVATE POPUP


** Screen set-up **

@23,0 FILL TO 23,79 COLOR N/W
@24,0 FILL TO 24,79 COLOR N

** Gives screen texture **
texture=REPLICATE(CHR(176),80)
x=0
DO WHILE x < 22
  x=x+1
  @x,0 SAY texture
ENDDO

** draw title box **
  SAVE SCREEN TO temp
  SHOW MENU main
  @6,25 CLEAR TO 14,57
  @6,25 FILL TO 14,57 COLOR W/W
  @15,27 FILL TO 15,59 COLOR W/N
  @7,58 FILL TO 15,59 COLOR W/N
  @6,25 TO 14,57 DOUBLE COLOR N/W
  @8,29 FILL TO 12,29 COLOR R/R
  @9,31 FILL TO 12,31 COLOR B+/B+
  @10,33 FILL TO 12,33 COLOR RB/RB
  @11,35 FILL TO 12,35 COLOR R+/R+
  @8,42 SAY "tGRAPH LINK" COLOR N/W
  @10,42 SAY "Version 1.0" COLOR N/W
  @13,29 SAY "Press any key to begin..." COLOR N/W*
  x=INKEY(0)
  RESTORE SCREEN FROM temp
  @23,32 SAY "tGRAPH LINK 1.0" COLOR R/W
  @23,0 SAY "[F10]" COLOR N/W
  @23,5 SAY "Draw graph" COLOR W+/GB

**********************
* MAIN LOOP          *
**********************
done=.F.
DO WHILE .NOT. done
  ACTIVATE MENU main
ENDDO


** Clean-up **
CLEAR
CLOSE DATA
RELEASE ALL
SET TALK ON
SET STAT ON
@1,1 SAY "Thank you for using tGraph."
@2,1 SAY "Please show your support by registering."


*********************
* EXIT PROGRAM      *
*********************
PROCEDURE exit_prog
  ON ERROR
  done=.T.
  DEACTIVATE MENU
RETURN

*  DO save_info

**********************
* GET PATTERNS       *
**********************
PROCEDURE get_patts
  ptr=BAR()
  ACTIVATE POPUP patt_list
  IF LEN(PROMPT())=0
    RETURN
  ENDIF
  IF BAR()=13
    pattern[ptr]=''
    patt_num[ptr]=1
  ELSE
    pattern[ptr]=LTRIM(TRIM(PROMPT()))
    patt_num[ptr]=BAR()-1
  ENDIF
  x=1
  DO WHILE x <= max_sets
    DEFINE BAR x OF patts_pop PROMPT "  Set "+STR(x,1,0)+" {"+TRIM(pattern[x])+"}  "
    x=x+1
  ENDDO
RETURN


**********************
* GET TYPE OF GRAPH  *
**********************
PROCEDURE get_graph
  bar=''
  line=''
  pie=''
  DO CASE
    CASE BAR()=1
      bar=CHR(251)
      graphtype='BAR'
    CASE BAR()=2
      line=CHR(251)
      graphtype='LINE'
    CASE BAR()=3
      pie=CHR(251)
      graphtype='PIE'
  ENDCASE
  DO def_graphs
RETURN


**************************
* GET TITLES             *
**************************
PROCEDURE get_titles
  SAVE SCREEN TO temp
  ptr=BAR()
  
  IF ptr > 4
    @11,24 CLEAR TO 13,51
    @11,24 TO 13,51
*    titles[ptr]=(titles[ptr]+SPACE(LEN(titles[ptr])-15))
    @12,26 SAY LTRIM(TRIM(SUBSTR(PROMPT(),1,9)))+":" GET titles[ptr];
         PICT "XXXXXXXXXXXXXXX"
  ELSE
    @11,24 CLEAR TO 13,66
    @11,24 TO 13,66
*    titles[ptr]=(titles[ptr]+SPACE(LEN(titles[ptr])-30))
    @12,26 SAY LTRIM(TRIM(SUBSTR(PROMPT(),1,9)))+":" GET titles[ptr];
       PICT "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
  ENDIF
  READ
*  titles[ptr]=TRIM(titles[ptr])
  RESTORE SCREEN FROM TEMP
  DO def_titles
RETURN


**********************************
* GET COLOR FOR SPECIFIC ELEMENT *
**********************************
PROCEDURE get_color
  ptr=BAR()
ACTIVATE POPUP color_list
  IF LEN(PROMPT())=0
    RETURN
  ENDIF
  IF BAR()=17
    IF ptr < 13  
      clrs[ptr]='White'
      clr_num[ptr]=15
    ELSE
      clrs[ptr]='Black'
      clr_num[ptr]=0
    ENDIF
  ELSE  
    clrs[ptr]=LTRIM(TRIM(PROMPT()))
    clr_num[ptr]=BAR()-1
  ENDIF
  DO def_color 
RETURN


******************************************
* GET DATA SET .DBF AND ASSOCIATED FIELD *
******************************************
PROCEDURE get_dbf
  ptr=BAR()
IF ptr=6
  ACTIVATE POPUP er_data
  IF BAR()=0
    RETURN
  ENDIF
  data[BAR()]=''
  field[BAR()]=''
  DO def_data
  RETURN
ENDIF
  ACTIVATE POPUP dbf_list
  IF LEN(PROMPT())=0
    RETURN
  ENDIF
  temp_name=PROMPT()
  temp_name=tr_filename()
  IF temp_name="TGDATA.DBF"
    ?? CHR(7)
    choice=DIALOG(1," Ok ","","",10,25,"Can't use TGDATA.DBF")
    RETURN
  ENDIF
  USE PROMPT()
  ON ERROR DO chk_error
** check for non dbase file *
  IF ERROR()=15
    CLOSE DATA
    ?? CHR(7)
    choice=DIALOG(1," Ok ","","",10,20,temp_name+" is not a dBASE database")
  ENDIF
  ON ERROR
  temp_name=PROMPT()  
  data[ptr]=tr_filename()
  USE &data[ptr]
  DEFINE POPUP field_list FROM 9,8 PROMPT STRUCTURE;
                          MESSAGE "Select a field from "+data[ptr]
  ON SELECTION POPUP field_list DEACTIVATE POPUP
  ACTIVATE POPUP field_list
  IF LEN(PROMPT())=0
    RETURN
  ENDIF
  data[ptr]=tr_filename()
  field[ptr]=PROMPT()
  DO CASE
    CASE ptr < 5
      DEFINE BAR ptr OF data_pop PROMPT;
              "  Set "+STR(ptr,1,0)+"  {"+data[ptr]+", "+PROMPT()+"}  "
    CASE ptr = 5
      DEFINE BAR 5 OF data_pop PROMPT;
              "  Labels {"+data[ptr]+", "+PROMPT()+"}  "
  ENDCASE
  USE
RETURN


***************************************
* REMOVE LEADING FILE NAME CHARACTERS *
***************************************
FUNCTION tr_filename
  x=LEN(temp_name)
  num_chars=0
** scan until last slash is found **
  DO WHILE SUBSTR(temp_name,x,1) <> "\"
    x=x-1
    num_chars=num_chars+1  
  ENDDO
  new=SUBSTR(temp_name,x+1,num_chars)
RETURN new


*********************************
* SAVES DATA TO GRDATA.DBF      *
*********************************
PROCEDURE save_data
  DO get_grname
  IF LEN(TRIM(grname)) = 0 .OR. LASTKEY()=27
    RETURN
  ENDIF
  SELE 2
  SEEK TRIM(grname)

  IF .NOT. EOF()
    ?? CHR(7)
    choice=DIALOG(2," Yes "," No ","",10,20,"Over write "+TRIM(grname)+"?")
      IF choice=2 .OR. choice=0
*        grname=
        RETURN
      ENDIF
  ELSE
    APPEND BLANK
  ENDIF
  
  REPLACE name WITH TRIM(grname)
  REPLACE fdata1 WITH data[1], fdata2 WITH data[2], fdata3 WITH data[3],fdata4 WITH data[4]
  REPLACE ffield1 WITH field[1],ffield2 WITH field[2],ffield3 WITH field[3],ffield4 WITH field[4]
  REPLACE fcolor1 WITH clrs[1],fcolor2 WITH clrs[2],fcolor3 WITH clrs[3],fcolor4 WITH clrs[4]
  REPLACE fpatt1 WITH pattern[1],fpatt2 WITH pattern[2],fpatt3 WITH pattern[3],fpatt4 WITH pattern[4]
  REPLACE fleg1 WITH titles[5],fleg2 WITH titles[6],fleg3 WITH titles[7],fleg4 WITH titles[8]
  REPLACE flabels WITH data[5],flabelfld WITH field[5]
  REPLACE ftitle1 WITH titles[1],ftitle2 WITH titles[2],fxtitle WITH titles[3],fytitle WITH titles[4]
  REPLACE fbkcolor WITH clrs[13],ft1color WITH clrs[6],ft2color WITH clrs[7]
  REPLACE fytcolor WITH clrs[9],fxtcolor WITH clrs[8],flgcolor WITH clrs[10]
  REPLACE fyscolor WITH clrs[11],fxlcolor WITH clrs[5],ffrcolor WITH clrs[12]
  REPLACE color1num WITH clr_num[1],color2num WITH clr_num[2],color3num WITH clr_num[3]
  REPLACE color4num WITH clr_num[4],xlcolornum WITH clr_num[5]
  REPLACE t1colornum WITH clr_num[6],t2colornum WITH clr_num[7]
  REPLACE xtcolornum WITH clr_num[8],ytcolornum WITH clr_num[9]
  REPLACE lgcolornum WITH clr_num[10],yscolornum WITH clr_num[11]
  REPLACE frcolornum WITH clr_num[12],bkcolornum WITH clr_num[13]
  REPLACE patt1num WITH patt_num[1],patt2num WITH patt_num[2]
  REPLACE patt3num WITH patt_num[3],patt4num WITH patt_num[3]
  REPLACE ftype WITH graphtype,fgrid WITH grid
  SELE 1
RETURN


********************************************************
* DETERMINE WHAT TO DO FROM FILES SECTION OF MAIN MENU *
********************************************************
PROCEDURE files_menu
  DO CASE
    CASE BAR()=1
      SELE 2
      ACTIVATE POPUP graph_list
      IF LEN(PROMPT())=0
        RETURN
      ENDIF
      DO load_graph
      SELE 1
    CASE BAR()=2
      DO save_data
    CASE BAR()=3
       IF LEN(data[1])=0 .AND. LEN(data[2])=0 .AND. LEN(data[3])=0;
         .AND. LEN(data[4])=0
         ?? CHR(7)
         choice=DIALOG(1," Ok ","","",10,20,"Must select data.")
         RETURN
       ENDIF
       DO get_fname
       IF LEN(TRIM(fname)) > 0
         DO make_tgr
       ENDIF
    CASE BAR()=4
      DO new_graph
  ENDCASE
RETURN

***********************************
* GET EXISTING GRAPH INFORMATION  *
***********************************
PROCEDURE load_graph
  IF EOF()
    ?? CHR(7)
    choice=DIALOG(1," Ok ","","",10,20,"There aren't any graphs stored.")
    RETURN
  ENDIF
  grname=TRIM(PROMPT())
  DEFINE BAR 1 OF file_pop PROMPT "  Load {"+grname+"}  "
  SEEK grname
  data[1]=TRIM(fdata1)
  data[2]=TRIM(fdata2)
  data[3]=TRIM(fdata3)
  data[4]=TRIM(fdata4)
  data[5]=TRIM(flabels)

  field[1]=ffield1
  field[2]=ffield2
  field[3]=ffield3
  field[4]=ffield4
  field[5]=flabelfld

  clrs[1]=fcolor1
  clrs[2]=fcolor2
  clrs[3]=fcolor3
  clrs[4]=fcolor4
  clrs[5]=fxlcolor
  clrs[6]=ft1color
  clrs[7]=ft2color
  clrs[8]=fxtcolor
  clrs[9]=fytcolor
  clrs[10]=flgcolor
  clrs[11]=fyscolor
  clrs[12]=ffrcolor
  clrs[13]=fbkcolor

  clr_num[1]=color1num
  clr_num[2]=color2num
  clr_num[3]=color3num
  clr_num[4]=color4num
  clr_num[5]=xlcolornum
  clr_num[6]=t1colornum
  clr_num[7]=t2colornum
  clr_num[8]=xtcolornum
  clr_num[9]=ytcolornum
  clr_num[10]=lgcolornum
  clr_num[11]=yscolornum
  clr_num[12]=frcolornum
  clr_num[13]=bkcolornum

  pattern[1]=fpatt1
  pattern[2]=fpatt2
  pattern[3]=fpatt3
  pattern[4]=fpatt4

  patt_num[1]=patt1num
  patt_num[2]=patt2num
  patt_num[3]=patt3num
  patt_num[4]=patt4num

  titles[1]=ftitle1
  titles[2]=ftitle2
  titles[3]=fxtitle
  titles[4]=fytitle
  titles[5]=fleg1
  titles[6]=fleg2
  titles[7]=fleg3
  titles[8]=fleg4

  graphtype=ftype
  grid=fgrid
  IF grid
    DEFINE BAR 1 OF grid_pop PROMPT "  On   "
  ELSE
    DEFINE BAR 1 OF grid_pop PROMPT "  Off  "
  ENDIF
  DO def_data
  DO def_color
  DO def_patts
  DO def_titles
RETURN


*********************************
* DEFINES POPUP OF GRAPH TYPES  *
*********************************
PROCEDURE def_graphs
  DEFINE BAR 1 OF graph_pop PROMPT "  Bar  "+bar
  DEFINE BAR 2 OF graph_pop PROMPT "  Line "+line+'  '
  DEFINE BAR 3 OF graph_pop PROMPT "  Pie  "+pie
RETURN

******************************
* DEFINES POPUP OF DBF'S     *
******************************
PROCEDURE def_data
  DEFINE BAR 1 OF data_pop PROMPT "  Set 1  {"+TRIM(data[1])+", "+TRIM(field[1])+"}  "
  DEFINE BAR 2 OF data_pop PROMPT "  Set 2  {"+TRIM(data[2])+", "+TRIM(field[2])+"}"
  DEFINE BAR 3 OF data_pop PROMPT "  Set 3  {"+TRIM(data[3])+", "+TRIM(field[3])+"}"
  DEFINE BAR 4 OF data_pop PROMPT "  Set 4  {"+TRIM(data[4])+", "+TRIM(field[4])+"}"
  DEFINE BAR 5 OF data_pop PROMPT "  Labels {"+TRIM(data[5])+", "+TRIM(field[5])+"}"
  DEFINE BAR 6 OF data_pop PROMPT "  Erase"
RETURN


***************************
* DEFINES POPUP OF COLORS *
***************************
PROCEDURE def_color
  DEFINE BAR 1 OF colors_pop PROMPT "  Set 1      {"+TRIM(clrs[1])+"}  "
  DEFINE BAR 2 OF colors_pop PROMPT "  Set 2      {"+TRIM(clrs[2])+"}  "
  DEFINE BAR 3 OF colors_pop PROMPT "  Set 3      {"+TRIM(clrs[3])+"}  "
  DEFINE BAR 4 OF colors_pop PROMPT "  Set 4      {"+TRIM(clrs[4])+"}  "
  DEFINE BAR 5 OF colors_pop PROMPT "  Label      {"+TRIM(clrs[5])+"}  "
  DEFINE BAR 6 OF colors_pop PROMPT "  Title 1    {"+TRIM(clrs[6])+"}  "
  DEFINE BAR 7 OF colors_pop PROMPT "  Title 2    {"+TRIM(clrs[7])+"}  "
  DEFINE BAR 8 OF colors_pop PROMPT "  X-title    {"+TRIM(clrs[8])+"}  "
  DEFINE BAR 9 OF colors_pop PROMPT "  Y-title    {"+TRIM(clrs[9])+"}  "
  DEFINE BAR 10 OF colors_pop PROMPT "  Legend     {"+TRIM(clrs[10])+"}  "
  DEFINE BAR 11 OF colors_pop PROMPT "  Y-scale    {"+TRIM(clrs[11])+"}  "
  DEFINE BAR 12 OF colors_pop PROMPT "  Frame      {"+TRIM(clrs[12])+"}  "
  DEFINE BAR 13 OF colors_pop PROMPT "  Background {"+TRIM(clrs[13])+"}  "
RETURN


***************************
* DEFINES POPUP OF TITLES *
***************************
PROCEDURE def_titles
  DEFINE BAR 1 OF titles_pop PROMPT "  Title 1  {"+(titles[1])+"}  "
  DEFINE BAR 2 OF titles_pop PROMPT "  Title 2  {"+(titles[2])+"}  "
  DEFINE BAR 3 OF titles_pop PROMPT "  X-axis   {"+(titles[3])+"}  "
  DEFINE BAR 4 OF titles_pop PROMPT "  Y-axis   {"+(titles[4])+"}  "
  DEFINE BAR 5 OF titles_pop PROMPT "  Legend 1 {"+(titles[5])+"}  "
  DEFINE BAR 6 OF titles_pop PROMPT "  Legend 2 {"+(titles[6])+"}  "
  DEFINE BAR 7 OF titles_pop PROMPT "  Legend 3 {"+(titles[7])+"}  "
  DEFINE BAR 8 OF titles_pop PROMPT "  Legend 4 {"+(titles[8])+"}  "
RETURN

*****************************
* DEFINES POPUP OF PATTERNS *
*****************************
PROCEDURE def_patts
  DEFINE BAR 1 OF patts_pop PROMPT "  Set 1 {"+TRIM(pattern[1])+"}  "
  DEFINE BAR 2 OF patts_pop PROMPT "  Set 2 {"+TRIM(pattern[2])+"}"
  DEFINE BAR 3 OF patts_pop PROMPT "  Set 3 {"+TRIM(pattern[3])+"}"
  DEFINE BAR 4 OF patts_pop PROMPT "  Set 4 {"+TRIM(pattern[4])+"}"
RETURN

****************
* RESETS VARS  *
****************
PROCEDURE new_graph
  DEFINE BAR 1 OF file_pop PROMPT "  Load {}"
  field[1]=SPACE(10)
  field[2]=SPACE(10)
  field[3]=SPACE(10)
  field[4]=SPACE(10)
  field[5]=SPACE(10)

  titles[1]=SPACE(30)
  titles[2]=SPACE(30)
  titles[3]=SPACE(30)
  titles[4]=SPACE(30)
  titles[5]=SPACE(15)
  titles[6]=SPACE(15)
  titles[7]=SPACE(15)  
  titles[8]=SPACE(15)
  
  x=1
  DO WHILE x <= max_sets  
    data[x]=''
    field[x]=''
    pattern[x]='Solid'
    patt_num[x]=1
    x=x+1    
  ENDDO
    x=1

  DO WHILE x<=max_colors
    clrs[x]='White'
    clr_num[x]=15
    x=x+1
  ENDDO
    clrs[13]='Black'
    clr_num[13]=0
  graphtype='BAR'
  bar=CHR(251)
  line='' 
  pie=''
  DO def_graph
  DO def_data
  DO def_color
  DO def_patts
  DO def_titles
RETURN


***************************
* WRITE DATA TO .TGR FILE *
***************************
PROCEDURE make_tgr
  SET SAFETY OFF
  choice=1
  out=SUBSTR(TRIM(fname),1,8)+".TGR"
  IF FILE(out) .AND. out <> "TEMP9999.TGR"
    ?? CHR(7)
    choice=DIALOG(2," Yes "," No ","",10,20,"File exists.  Overwrite?")
  ENDIF
    IF choice=2 .OR. choice=0
      RETURN
    ENDIF

  SET ALTERNATE TO "&out"
  SET ALTERNATE ON
  SET CONSOLE OFF
  ?
  ?? "GRAPH("+TRIM(graphtype)+")"
  ?
  IF grid
    ?? "GRID"
    ?
  ENDIF
  x=1
  DO WHILE x <= max_sets-1
  IF LEN(TRIM(data[x])) > 0 
    ?? "DATA("+TRIM(data[x])+","+TRIM(field[x])+","+STR(patt_num[x],2,0)+","+STR(clr_num[x],2,0)+","+'"'+TRIM(titles[x+4])+'")'
    ?
  ENDIF
  x=x+1
  ENDDO
  
  IF LEN(TRIM(data[5])) <> 0
    ?? "LABELS("+TRIM(data[5])+","+TRIM(field[5])+")"
     ?
  ENDIF
  ?? "TITLES("+'"'+TRIM(titles[1])+'",'+'"'+TRIM(titles[2])+'",'+'"'+ ;
     TRIM(titles[3])+'",'+'"'+TRIM(titles[4])+'"'+')'
  ?
  ?? "COLORS("+STR(clr_num[6],2,0)+","+STR(clr_num[7],2,0)+","+STR(clr_num[8],2,0)+;
     ","+STR(clr_num[9],2,0)+","+STR(clr_num[5],2,0)+","+STR(clr_num[10],2,0)+;
     ","+STR(clr_num[11],2,0)+","+STR(clr_num[12],2,0)+","+STR(clr_num[13],2,0)+')'
  ?
 
  CLOSE ALTERNATE
  SET ALTERNATE OFF
  SET SAFETY ON 
  SET CONSOLE ON
RETURN

**********************
* GET .TGR FILE NAME *
**********************
PROCEDURE get_fname
  SAVE SCREEN TO temp
  @7,1 CLEAR TO 9,32
  @7,1 TO 9,32
  @8,2 SAY "Filename:"
  @8,12 GET fname PICT "NNNNNNNNNNNNNNNNNNNN"
  READ
  RESTORE SCREEN FROM temp
RETURN


**********************
* GET GRAPH NAME     *
**********************
PROCEDURE get_grname
  SAVE SCREEN TO temp
  @7,1 CLEAR TO 9,29
  @7,1 TO 9,29
  @8,2 SAY "Graph name:"
  @8,14 GET grname
  READ
  DEFINE BAR 1 OF file_pop PROMPT "  Load {"+TRIM(grname)+"}  "
  RESTORE SCREEN FROM temp
RETURN


***************************************
* CALL TGRAPH.EXE WHEN F10 IS PRESSED *
***************************************
PROCEDURE draw_graph
  IF LEN(data[1])=0 .AND. LEN(data[2])=0 .AND. LEN(data[3])=0;
    .AND. LEN(data[4])=0
    ?? CHR(7)
    choice=DIALOG(1," Ok ","","",10,20,"Must select data.")
    RETURN
  ENDIF
  IF .NOT. FILE("TGRAPH.EXE")
    choice=DIALOG(1," Ok ","","",10,25,"Can't find TGRAPH.EXE.")
    RETURN
  ENDIF
  SAVE SCREEN TO temp
  SET COLOR OF NORM TO W+/N
  fname="TEMP9999.TGR"
  DO make_tgr
  RUN TGRAPH.EXE TEMP9999.TGR
  DELETE FILE TEMP9999.TGR
  fname=SPACE(20)
  RESTORE SCREEN FROM temp
  SET COLOR OF NORM TO W+/B
RETURN


*********************
* TURN GRID ON/OFF  *
*********************
PROCEDURE get_grid
  IF BAR()=1
  IF grid
    grid=.F.
    DEFINE BAR 1 OF grid_pop PROMPT "  Off  "
  ELSE
    grid=.T.
    DEFINE BAR 1 OF grid_pop PROMPT "  On   "  
  ENDIF    
  ENDIF
  KEYBOARD CHR(19)
  KEYBOARD CHR(4)
RETURN
